#include"iodefine.h"
#include<stdarg.h>
#include<string.h>
#include<ctype.h>
#include"LcdLib.h"

/*̂߂̕ϐE`*/
const char hex[]="0123456789abcdef";
const char HEX[]="0123456789ABCDEF";
static void (*outDev)(char c);
static char lcd[4][21];/*work area*/
static unsigned lcdx,lcdy,maxx,maxy;
static char *buf; /*for sprintf*/

#ifdef AKI_H8_USB
static char bkupLed;
#endif

static void initSCI1(void)/*VAR~jP[VC^[tF[X1̐ݒ*/
{
    unsigned char dummy;
    SCI1.SCR.BYTE=0x00; /*P497 荞݁EM֎~*/
    SCI1.SMR.BYTE=0x00; /*P491  f[^8bit NoParity StopBit 1*/
#ifdef H8_3048F16
    SCI1.BRR=12;        /*P504 38400bps CPU=16MHz:12, 25MHz:19*/
#endif
#if defined(H8_3052F25)||defined(H8_3048FONE)
    SCI1.BRR=19;        /*P504 38400bps CPU=16MHz:12, 25MHz:19*/
#endif
    waitus(50);         /*1/38400s҂*/
    SCI1.SCR.BYTE=0x30; /*P495M*/
    dummy=SCI0.SSR.BYTE;/*p499_~[[h*/
    SCI1.SSR.BYTE=0x80; /*P497 G[tONA1000 0000*/
}

static void putBuf(char c)
{
    *buf = c; buf++;
}

static void putCharSCI1(char c)
{
    if(c=='\n') putCharSCI1('\r');      /*s*/
	while((SCI1.SSR.BYTE & 0x80)==0);   /*ŏʃrbg1Ȃ瑗M\*/
	SCI1.TDR = c;                       /*p490Transmit Data RegisterɃf[^*/
	SCI1.SSR.BIT.TDRE = 0;              /*tONA*/
}

static void lcdout(char lcddata)
{
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
    P3.DR.BYTE=lcddata;
    P3.DR.BIT.B5=1;/*E='H'*/
    waitus(40);/*ɂŏl(250ns?)*/
    P3.DR.BIT.B5=0;/*E='L'*/
    waitus(40);/*ɂŏl(250ns?)*/
#endif
#ifdef AKI_H8_USB
    PB.DR.BYTE=lcddata;
    PB.DR.BIT.B7=1;/*E='H'*/
    waitus(40);/*ɂŏl(250ns?)*/
    PB.DR.BIT.B7=0;/*E='L'*/
    waitus(40);/*ɂŏl(250ns?)*/
#endif
}

static void init_lcd(void)
{
    waitms(15);  /*15ms wait*/
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
    P3.DR.BYTE=0x00;/*E,RS ='L'*/
#endif
#ifdef AKI_H8_USB
    PB.DR.BYTE=0x00;/*E,RS ='L'*/
#endif
    lcdout(0x03);/*function set*/
    waitus(4100);   /*4.1ms wait*/
    lcdout(0x03);/*function set*/
    waitus(100);    /*100s wait*/
    lcdout(0x03);/*function set*/
    lcdout(0x02);/*function set 4biti錾j*/
    lcdout(0x02);/*function set 4bit*/
    lcdout(0x08);/* 1/16duty,5*7dot*/
    lcdout(0x00);/*\on,J[\off,nonuN*/
    lcdout(0x0c);/**/
    lcdout(0x00);/*entry mode set, adr+1=cursol right,*/
    lcdout(0x06);/* non shift=non scroll*/
}

static void init_device(void)/*|[g̏*/
{
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
    P2.DDR=0x00;/*P2-0-7 = fBbvSW LOW=on*/
    P2.PCR.BYTE=0xff;/*P2-0-7 Pull Up ݒ*/
    P3.DDR=0xff;/*port3(lcd) = all output*/
                /*NC,NC,E,RS,D7,D6,D5,D4*/
    P4.DDR=0x00;/*P4-4-7 = ^NgSW LOW=on*/
    P4.PCR.BYTE=0xff;/*P4-4-7 Pull Up ݒ*/
    P5.DDR=0xff;/*P5-0,1 = LED  High=on*/
#endif
#ifdef AKI_H8_USB
    PA.DDR=0x00;/*PA-0-3 = fBbvSW LOW=on*/
    PB.DDR=0xff;/*portB(lcd) = all output*/
                /*E,NC,NC,RS,D7,D6,D5,D4*/
#endif
}

void init_mother_system(void)/*SVXȅ*/
{
    unsigned i,j;
    init_device();
    init_lcd();
    initSCI1();
    for(i=0;i<4;i++) for(j=0;j<21;j++) lcd[i][j]=' ';
    seldevice(LCD); /*ftHg*/
    maxx=15; maxy=1;
    lcdsize(C16L2);
    lcdx=lcdy=0;
    buf=NULL;
	clrscr();
	ledoff(ALL);
}

void clrscr(void)                       /*kbcʃNA*/
{
    unsigned i,j;
#ifdef AKI_H8_USB
	bkupLed=PB.DR.BYTE;/*AKI-H8-USBp*/
    PB.DR.BYTE=0x00;/*E,RS ='L'*/
#endif
    lcdout(0x00);   lcdout(0x01);    waitus(3100);

    lcdx=lcdy=0;
    for(i=0;i<4;i++) for(j=0;j<20;j++) lcd[i][j]=' ';
#ifdef AKI_H8_USB
	PB.DR.BYTE=bkupLed;/*AKI-H8-USBp*/
#endif
}

/*ʃVtg*//*
void lcdshift(unsigned num)
{
    unsigned i;
    PB.DR.BYTE=0x00;*//*E,RS ='L'*//*
    for(i=0;i<num;i++){
        lcdout(0x01);   lcdout(0x08);
    }
}*/

void gotoxy(unsigned x,unsigned y)      /*kbcJ[\ړ*/
{
    unsigned char loc;
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
//	bkupLed=PB.DR.BYTE;/*AKI-H8-USBp*/
    PB.DR.BYTE=0x00;/*E,RS ='L'*/
#endif
    if(y<2) loc=0x80+x+0x40*y;
    else loc=0x80+x+0x14+0x40*(y-2);
    lcdout((loc>>4)&0x0f);
    lcdout(((loc)&0x0f));
    lcdx=x; lcdy=y;
#ifdef AKI_H8_USB
	PB.DR.BYTE=bkupLed;/*AKI-H8-USBp*/
#endif
}

static void lcdscroll(void)
{
    unsigned i;
    for(i=1;i<=maxy;i++){
        gotoxy(0,i-1); devprintf(LCD,"%s",lcd[i]);
    }
    for(i=0;i<=maxx;i++) lcd[maxy][i]=' ';
    gotoxy(0,maxy); devprintf(LCD,"%s",lcd[maxy]);
}

static void putCharLCD(char c)
{
    unsigned char temp;

    if( c=='\r'){ gotoxy(lcdy,0); return;}
    if( lcdx>maxx || c=='\n'){
        lcdx=0;
        if((++lcdy)>maxy){ lcdscroll(); lcdx=0; lcdy=maxy;}
        gotoxy(lcdx,lcdy);
        if(c=='\n') return;
    }
    lcd[lcdy][lcdx++]=c;

    temp=0x10; temp|=(c>>4)&0x0f; lcdout(temp);
    temp=0x10; temp|=(c&0x0f);    lcdout(temp);

}

void turnOnLed(led_type sel)                /*LED ON*/
{
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
	if(sel&0x01) P5.DR.BIT.B0=1;
	if(sel&0x02) P5.DR.BIT.B1=1;
#endif
#ifdef AKI_H8_USB
	/*E(bit7)ɂĂ͏Loŵ*/
	if(sel&0x01) PB.DR.BIT.B0=0;
	if(sel&0x02) PB.DR.BIT.B1=0;
	if(sel&0x04) PB.DR.BIT.B2=0;
	if(sel&0x08) PB.DR.BIT.B3=0;
#endif
}

void turnOffLed(led_type sel)               /*LED OFF*/
{
#if defined(AE_H8MB)||defined(MD_M52F_48F1)
	if(sel&0x01) P5.DR.BIT.B0=0;
	if(sel&0x02) P5.DR.BIT.B1=0;
#endif
#ifdef AKI_H8_USB
	if(sel&0x01) PB.DR.BIT.B0=1;
	if(sel&0x02) PB.DR.BIT.B1=1;
	if(sel&0x04) PB.DR.BIT.B2=1;
	if(sel&0x08) PB.DR.BIT.B3=1;
#endif
}

void waitms(unsigned ms)
{/*msec̑҂*/
    unsigned i,j;
#ifdef H8_3048F16
    for(i=0;i<ms;i++) for(j=0;j<1588;j++);
#endif
#if defined(H8_3052F25)||defined(H8_3048FONE)
    for(i=0;i<ms;i++) for(j=0;j<2500;j++);
#endif
}

void waitus(unsigned u)
{/*microsec̑҂*/
#ifdef H8_3048F16
    unsigned v=u;
    while(u!=0) u--;
    while(v!=0) v--;
#endif
#if defined(H8_3052F25)||defined(H8_3048FONE)
    unsigned w,v;
    w=v=u;
    while(u!=0) u--;
    while(v!=0) v--;
    while(w!=0) w--;
#endif
}

char *ctoa(char value, char *string, int radix)/*ok*/
{
    unsigned char u=value;
    char temp[9];
    unsigned i=7;
    temp[8]='\0';

    if(value<0 && radix==10) u=-value;
    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }
    if(radix==10 && value<0) temp[i--]='-';
    strcpy(string,&temp[++i]);
    return string;
}
char *uctoa(unsigned char value, char *string, int radix)/*ok*/
{
    unsigned char u=value;
    char temp[9];
    unsigned i=7;
    temp[8]='\0';


    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }

    strcpy(string,&temp[++i]);
    return string;
}
char *itoa(short int value, char *string, int radix)/*ok*/
{
    unsigned short u=value;
    char temp[17];
    unsigned i=15;
    temp[16]='\0';

    if(value<0 && radix==10) u=-value;
    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }
    if(radix==10 && value<0) temp[i--]='-';
    strcpy(string,&temp[++i]);
    return string;
}
char *uitoa(unsigned short value, char *string, int radix)/*ok*/
{
    unsigned short u=value;
    char temp[17];
    unsigned i=15;
    temp[16]='\0';


    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }

    strcpy(string,&temp[++i]);
    return string;
}
char *ltoa(long value, char *string, int radix)/*ok*/
{
    unsigned long u=value;
    char temp[33];
    unsigned i=31;
    temp[32]='\0';

    if(value<0 && radix==10) u=-value;
    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }
    if(radix==10 && value<0) temp[i--]='-';
    strcpy(string,&temp[++i]);
    return string;
}
char *ultoa(unsigned long value, char *string, int radix)
{
    unsigned long u=value;
    char temp[33];
    unsigned i=31;
    temp[32]='\0';


    if(u==0) temp[i--]='0';
    else while(u!=0){ temp[i--]=hex[u%radix]; u/=radix; }

    strcpy(string,&temp[++i]);
    return string;
}

static void ___prints(char *data)      /*foCXɕ\C, ___=lcd or sci*/
{/*̏o*/
    while(*data){ (*outDev)(*data); data++; }
}

static void fill(char c,unsigned char num)
{
    while(num-- !=0) (*outDev)(c);
}

static void print_s(unsigned char flag,unsigned char width,/*unsigned char prefix,*/char *s)
{
    unsigned len;
    len=strlen(s);
    if(width==0)       ___prints(s);                        /*l*/
    else if(len>width) ___prints(s);                        /*error*/
    else if(flag&0x02){ ___prints(s); fill(' ',width-len);} /*-l*/
    else              { fill(' ',width-len); ___prints(s);} /*El*/
}

static void print_c(unsigned char flag,unsigned char width,/*unsigned char prefix,*/int c)
{
    char s[2];
    s[0]=c; s[1]='\0';
    print_s(flag,width,/*prefix,*/s);
}

static void print_i(unsigned char flag,unsigned char width,unsigned char prefix,unsigned char type,unsigned x,unsigned long lx)
{
    char temp[81],str[9];
    unsigned char uc;
    unsigned i=0,j,num=0,n;

    switch(type)/*0x,0X,*/{
        case 'x': case 'X':
            if(flag&0x20){ temp[i++]='0'; temp[i++]=type; num+=2;}/*#*/
            switch(prefix){
                case 'l':           ultoa(lx,str,16); break;
                case 'h': default:  uitoa( x,str,16); break;
            }
            break;
        case 'u':
            if(flag&0x04){ temp[i++]='+'; num++;}
            if(flag&0x08){ temp[i++]=' '; num++;}
            switch(prefix){
                case 'l':           ultoa(lx,str,10); break;
                case 'h': default:  uitoa( x,str,10); break;
            }
            break;
        case 'i': case 'd':
            if(flag&0x04){ temp[i++]=(lx<0 ? '-':'+'); num++;}
            if(flag&0x08){ temp[i++]=(lx<0 ? '-':' '); num++;}
            switch(prefix){
                case 'l':            ltoa(lx,str,10); break;
                case 'h': default:   itoa( x,str,10); break;
            }
            break;
        case 'b': /*gdlCw肵݂̂Qi\C8rbĝ*/
            uc=x; uctoa(uc,str,2);
            n=strlen(str);
            if(width!=0 && width<n) for(j=0;j<width+1;j++) str[j]=str[j+(n-width)];
            break;
    }

    num+=strlen(str);       /*[Ŗ߂鏈*/
    if(width>num && flag&0x10) while(width>num){ temp[i++]='0'; num++;}
    strcpy(&temp[i],str);
    i=0;                    /*啶ϊ*/
    if(type=='X') while(temp[i]!='\0'){ temp[i]=toupper(temp[i]); i++;}
    print_s(flag,width,/*prefix,*/temp);
}

static void printfBody(va_list ap,char *format)
{
//    unsigned i;
//    char str[81];
//    char *s;
    unsigned char flag=0,width=0,prefix=0,type=0;
#ifdef AKI_H8_USB
	bkupLed=PB.DR.BYTE;/*AKI-H8-USBp*/
#endif
    while(*format){
        if(flag==0){
            if(*format=='\\'){/*GXP[vV[PX*/
                format++;
                switch(*format){
                    case '\\': (*outDev)('\\'); break;
                    case 'n':  (*outDev)('\n'); break;
                    case 'r':  (*outDev)('\r'); break;
                }
            }else if(*format=='%'){ flag|=0x01;}
            else{ (*outDev)(*format);}
        }else{/*%̉*/
            if(*format=='%'){ (*outDev)(*format); flag=0;}
            else{
                if( !(width==0 && (*format)=='0') && '0'<=(*format) && (*format)<='9'){ width=width*10+((*format)-'0');}
                else{
                    switch(*format){
                        case '-': if(!(flag&0x10)) flag|=0x02; break;/*l*/
                        case '+': if(!(flag&0x08)) flag|=0x04; break;/*}t*/
                        case ' ': if(!(flag&0x04)) flag|=0x08; break;/*-orSpacet*/
                        case '0': if(!(flag&0x02)) flag|=0x10; break;/*0Ŗ߂*/
                        case '#': flag|=0x20; break;                 /*0x,0X*/
                        case 'h': case 'l': case 'L':
                            prefix=*format; break;
                        case 'd': case 'i': case 'o': case 'u': case 'x':
                        case 'X': case 'c': case 's': case 'f': case 'e':
                        case 'E': case 'g': case 'G': case 'p': case 'b':
                            type= *format; break;
                    }
                    if(type!=0){
                        switch(type){
                            case 'd': case 'i': case 'u': case 'x': case 'X':
                                switch(prefix){
                                    case 'l':
                                        print_i(flag,width,prefix,type,0,va_arg(ap,unsigned long)); break;
                                    case 'h': default:
                                        print_i(flag,width,prefix,type,va_arg(ap,unsigned short),0); break;
                                }
                                break;
                            case 'c': print_c(flag,width,/*prefix,*/va_arg(ap,int)); break;
                            case 's': print_s(flag,width,/*prefix,*/va_arg(ap,char*)); break;
                            case 'b': print_i(flag,width,prefix,type,va_arg(ap,int),0); break;
                        }
                        flag=width=prefix=type=0;
                    }
                }
            }
        }
        format++;
    }
#ifdef AKI_H8_USB
	PB.DR.BYTE=bkupLed;/*AKI-H8-USBp*/
#endif
}

void printf(const char *format,...)
{
    va_list ap;
    va_start(ap,format);
    printfBody(ap,format);
}

void devprintf(devType device,const char *format,...)
{
void (*bkup)(char c);
    va_list ap;
    va_start(ap,format);
bkup=outDev;
seldevice(device);
    printfBody(ap,format);
outDev=bkup;
}

void sprintf(char *buffer, const char *format, ...)
{
    void (*bkup)(char c);
    va_list ap;
    va_start(ap,format);
    bkup=outDev;
    outDev=putBuf;
    buf=buffer;
        printfBody(ap,format); (*outDev)('\0');
    buf=NULL;
    outDev=bkup;
}

void seldevice(devType device)    /*o͐̑I*/
{
    switch(device){
        case SCI_1: outDev=putCharSCI1; break;
        case LCD:   outDev=putCharLCD;  break;
    }
}

void lcdsize(sizeType size)    /*o͐̑I*/
{
    unsigned i;
    for(i=0;i<=maxy;i++) lcd[i][maxx+1]=' ';
    switch(size){
        case C20L4: maxx=19; maxy=3; break;
        case C16L2: maxx=15; maxy=1; break;
    }
    for(i=0;i<=maxy;i++) lcd[i][maxx+1]='\0';
}

/*printfƓl̂kbcւ̏to͊֐*/
/*gƍŒ43kbyteR[h𑝂₷*/
/*݂Ȃvsprintf퓮삵Ȃ*//*
void lcdprintf(char *format,...)
{
    char lcdstr[81];
    va_list argptr;
    va_start(argptr,format);
    vsprintf(lcdstr,format,argptr);
    lcdprints(lcdstr);
}*/
